/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventConversation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventConversation{}

// WebhookEventConversation struct for WebhookEventConversation
type WebhookEventConversation struct {
	Id string `json:"id"`
	Labels []string `json:"labels,omitempty"`
	Blocked bool `json:"blocked"`
	BlockedInfo *string `json:"blocked_info,omitempty"`
	CustomData *WebhookEventConversationCustomData `json:"custom_data,omitempty"`
}

// NewWebhookEventConversation instantiates a new WebhookEventConversation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventConversation(id string, blocked bool) *WebhookEventConversation {
	this := WebhookEventConversation{}
	this.Id = id
	this.Blocked = blocked
	return &this
}

// NewWebhookEventConversationWithDefaults instantiates a new WebhookEventConversation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventConversationWithDefaults() *WebhookEventConversation {
	this := WebhookEventConversation{}
	return &this
}

// GetId returns the Id field value
func (o *WebhookEventConversation) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WebhookEventConversation) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WebhookEventConversation) SetId(v string) {
	o.Id = v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *WebhookEventConversation) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversation) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *WebhookEventConversation) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *WebhookEventConversation) SetLabels(v []string) {
	o.Labels = v
}

// GetBlocked returns the Blocked field value
func (o *WebhookEventConversation) GetBlocked() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value
// and a boolean to check if the value has been set.
func (o *WebhookEventConversation) GetBlockedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Blocked, true
}

// SetBlocked sets field value
func (o *WebhookEventConversation) SetBlocked(v bool) {
	o.Blocked = v
}

// GetBlockedInfo returns the BlockedInfo field value if set, zero value otherwise.
func (o *WebhookEventConversation) GetBlockedInfo() string {
	if o == nil || IsNil(o.BlockedInfo) {
		var ret string
		return ret
	}
	return *o.BlockedInfo
}

// GetBlockedInfoOk returns a tuple with the BlockedInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversation) GetBlockedInfoOk() (*string, bool) {
	if o == nil || IsNil(o.BlockedInfo) {
		return nil, false
	}
	return o.BlockedInfo, true
}

// HasBlockedInfo returns a boolean if a field has been set.
func (o *WebhookEventConversation) HasBlockedInfo() bool {
	if o != nil && !IsNil(o.BlockedInfo) {
		return true
	}

	return false
}

// SetBlockedInfo gets a reference to the given string and assigns it to the BlockedInfo field.
func (o *WebhookEventConversation) SetBlockedInfo(v string) {
	o.BlockedInfo = &v
}

// GetCustomData returns the CustomData field value if set, zero value otherwise.
func (o *WebhookEventConversation) GetCustomData() WebhookEventConversationCustomData {
	if o == nil || IsNil(o.CustomData) {
		var ret WebhookEventConversationCustomData
		return ret
	}
	return *o.CustomData
}

// GetCustomDataOk returns a tuple with the CustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversation) GetCustomDataOk() (*WebhookEventConversationCustomData, bool) {
	if o == nil || IsNil(o.CustomData) {
		return nil, false
	}
	return o.CustomData, true
}

// HasCustomData returns a boolean if a field has been set.
func (o *WebhookEventConversation) HasCustomData() bool {
	if o != nil && !IsNil(o.CustomData) {
		return true
	}

	return false
}

// SetCustomData gets a reference to the given WebhookEventConversationCustomData and assigns it to the CustomData field.
func (o *WebhookEventConversation) SetCustomData(v WebhookEventConversationCustomData) {
	o.CustomData = &v
}

func (o WebhookEventConversation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventConversation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	toSerialize["blocked"] = o.Blocked
	if !IsNil(o.BlockedInfo) {
		toSerialize["blocked_info"] = o.BlockedInfo
	}
	if !IsNil(o.CustomData) {
		toSerialize["custom_data"] = o.CustomData
	}
	return toSerialize, nil
}

type NullableWebhookEventConversation struct {
	value *WebhookEventConversation
	isSet bool
}

func (v NullableWebhookEventConversation) Get() *WebhookEventConversation {
	return v.value
}

func (v *NullableWebhookEventConversation) Set(val *WebhookEventConversation) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventConversation) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventConversation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventConversation(val *WebhookEventConversation) *NullableWebhookEventConversation {
	return &NullableWebhookEventConversation{value: val, isSet: true}
}

func (v NullableWebhookEventConversation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventConversation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


